Unit DE21RP_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE21RP(var A :Array of Real; var B :Array of Real;
                var IPVT :Array of Real; N :Integer; IA :Integer;
                var X :Array of Real);

implementation

procedure DE21RP(var A :Array of Real; var B :Array of Real;
                var IPVT :Array of Real; N :Integer; IA :Integer;
                var X :Array of Real);
var
I,IW,IP,IM1,J,IP1,IB :Integer;
SUM :Real;
label
_1,_2,_3,_4,_5,_6;
begin
for I:=1 to N do
 begin
_1:
  X[I-1] := B[I-1];
 end;
IW := 0;
for I:=1 to N do
 begin
  IP := Trunc( IPVT[I-1] );
  SUM := X[IP-1];
  X[IP-1] := X[I-1];
  if ( IW = 0 ) 
   then goto _3;
  IM1 := I-1;
  for J:=IW to IM1 do
   begin
    SUM := SUM-A[(I-1)+(J-1)*IA]*X[J-1];
_2:
   end;
  goto _4;
_3:
  if ( SUM <> 0.0 ) 
   then IW := I;
_4:
  X[I-1] := SUM;
 end;
for IB:=1 to N do
 begin
  I := N+1-IB;
  IP1 := I+1;
  SUM := X[I-1];
  if ( IP1 > N ) 
   then goto _6;
  for J:=IP1 to N do
   begin
    SUM := SUM-A[(I-1)+(J-1)*IA]*X[J-1];
_5:
   end;
_6:
  X[I-1] := SUM/A[(I-1)+(I-1)*IA];
 end;
end;

end.
